""" Simple, readable key-value serialization """

def dump(data, f, terminator='\n', strip=True, final_terminator=True):
    f.write(dumps(data, terminator=terminator, strip=strip,
                  final_terminator=final_terminator))

def dumps(data, terminator='\n', strip=True, final_terminator=True):
    pairs = []
    for k, v in data.items():
        if strip:
            k = k.strip()
            v = v.strip()
        pairs.append("%s=%s" % (k,v))

    if final_terminator:
        pairs.append('')

    return terminator.join(pairs)

def loads(s, terminator='\n', strip=True, final_terminator=True):
    kv = {}
    if final_terminator:
        s = s.rstrip(terminator)
    for pair in s.split(terminator):
        k, v = pair.split('=', 1)
        if strip:
            k = k.strip()
            v = v.strip()
        kv[k] = v
    return kv

def load(f, terminator='\n', strip=True):
    return loads(f.read(), terminator=terminator, strip=strip)

