import os
import errno
import logging
import logging.handlers

def safe_mkdir(path, recursive=True):
    """ mkdir, nop if already exists """
    try:
        if recursive:
            os.makedirs(path)
        else:
            os.mkdir(path)
    except OSError, e:
        if e.errno != errno.EEXIST:
            raise

def safe_rmdir(path):
    """ rmdir, nop if it doesn't exist """
    try:
        os.rmdir(path)
    except OSError, e:
        if e.errno != errno.ENOENT:
            raise


def make_logger():
    # TODO: add configuration file
    logger = logging.getLogger('filecache')
    logger.setLevel(logging.DEBUG)
    LOG_FILENAME = '/tmp/log/filecache.log'
    safe_mkdir(os.path.dirname(LOG_FILENAME))
    logger.addHandler(logging.handlers.RotatingFileHandler(
                      LOG_FILENAME, maxBytes=2*1024*1024, backupCount=5))
    return logger

logger = make_logger()
