import sys
import time
from filecache import logger
from common import URLFileCache, TEST_URLS

if __name__ == "__main__":
    try:
        repeat = int(sys.argv[1])
    except IndexError:
        repeat = 5

    start_time = time.time()
    cache = URLFileCache('/tmp/urlcache', max_keys=7, pruning_interval=1)

    for i in range(repeat):
        for url in TEST_URLS:
            for chunk in cache.get_url(url):
                pass

    logger.info("test ran in %.2f secs" % (time.time() - start_time))
    cache.clear(rmdir=True) # cleanup our mess


